/*
 * ##################################################
 * #                                                #
 * # rkToolZ                                        #
 * # Simple apps programmed for fun with Java       #
 * #                                                #
 * # Copyright (C) by René Knipschild               #
 * #                                                #
 * #                                email@rkcsd.com #
 * #                         www.reneknipschild.net #
 * #                                                #
 * ##################################################
 *
 * File: TicTacToe.java - apps
 * Version: 1.0.1
 * Last modified: 2009/03/11 13:42 CET
 * Author: DeeDee0815
 *
 * ===Notes==========================================
 * There are currently no notes.
 * ==================================================
 */

//package net.reneknipschild.rktoolz.apps;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingUtilities;
import javax.swing.WindowConstants;

public class TicTacToe {
	private JFrame window;

	private JPanel frame;

	private int fields;

	private String[] signs;

	private JButton[][] field;

	private int sign;

	private JPanel options;

	private JLabel fieldsLabel;

	private JSpinner fieldsInput;

	private JLabel signsLabel;

	private JTextField signsInput;

	private JButton confirmButton;

	private JPanel game;

	private Color defaultColor = new JButton().getForeground();

	private Color grayedColor = Color.GRAY;

	public static void main(String[] args) {
		new TicTacToe();
	}

	public TicTacToe() {
		this.window = new JFrame("rkTicTacToe");
		//this.window.setIconImage(Toolkit.getDefaultToolkit().getImage(ClassLoader.getSystemResource("net/reneknipschild/rktoolz/data/Icon.png")));
		this.window.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
		this.frame = new JPanel(new BorderLayout());
		this.frame.setBorder(BorderFactory.createEmptyBorder(4, 4, 4, 4));

		this.options = new JPanel();
		GridBagLayout layout = new GridBagLayout();
		this.game = new JPanel();
		this.fieldsLabel = new JLabel("Fields:");
		this.fieldsInput = new JSpinner(new SpinnerNumberModel(3, 1, 25, 1));
		this.signsLabel = new JLabel("Signs:");
		this.signsInput = new JTextField("X;O");
		this.confirmButton = new JButton("Start");

		this.options.setLayout(layout);
		this.game.setBorder(BorderFactory.createEmptyBorder(4, 4, 4, 4));
		this.game.setPreferredSize(new Dimension(400, 300));
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				TicTacToe.this.confirmButton.requestFocusInWindow();
			}
		});

		layout.setConstraints(this.fieldsLabel, this.createGridBagConstraints(0, 0, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, 0, 0, 0, 0));
		layout.setConstraints(this.fieldsInput, this.createGridBagConstraints(1, 0, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, 1, 0, 0, 0));
		layout.setConstraints(this.signsLabel, this.createGridBagConstraints(2, 0, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, 0, 0, 0, 0));
		layout.setConstraints(this.signsInput, this.createGridBagConstraints(3, 0, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, 10, 0, 0, 0));
		layout.setConstraints(this.confirmButton, this.createGridBagConstraints(4, 0, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, 0, 0, 25, 0));

		this.confirmButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				TicTacToe.this.start(Integer.parseInt(TicTacToe.this.fieldsInput.getValue().toString()), TicTacToe.this.signsInput.getText().split(";"));
			}
		});

		this.options.add(this.fieldsLabel);
		this.options.add(this.fieldsInput);
		this.options.add(this.signsLabel);
		this.options.add(this.signsInput);
		this.options.add(this.confirmButton);

		this.frame.add(this.options, BorderLayout.NORTH);
		this.frame.add(this.game, BorderLayout.CENTER);

		this.window.add(this.frame, BorderLayout.CENTER);
		this.window.pack();
		this.window.setResizable(true);
		this.window.setLocationRelativeTo(null);
		this.window.setVisible(true);
	}

	private GridBagConstraints createGridBagConstraints(int gridx, int gridy, int gridwidth, int gridheight, int anchor, int fill, double weightx, double weighty, int ipadx, int ipady) {
		GridBagConstraints gridbagconstraints = new GridBagConstraints();
		gridbagconstraints.gridx = gridx;
		gridbagconstraints.gridy = gridy;
		gridbagconstraints.gridwidth = gridwidth;
		gridbagconstraints.gridheight = gridheight;
		gridbagconstraints.anchor = anchor;
		gridbagconstraints.fill = fill;
		gridbagconstraints.weightx = weightx;
		gridbagconstraints.weighty = weighty;
		gridbagconstraints.insets = new Insets(4, 4, 4, 4);
		gridbagconstraints.ipadx = ipadx;
		gridbagconstraints.ipady = ipady;
		return gridbagconstraints;
	}

	private void start(int fields, String[] signs) {
		this.sign = 0;
		this.fields = fields;
		this.signs = signs;
		this.game.removeAll();
		this.field = new JButton[this.fields][this.fields];
		this.game.setLayout(new GridLayout(this.fields, this.fields, 8, 8));
		for (int i = 0; i < this.fields; i++) {
			for (int j = 0; j < this.fields; j++) {
				this.field[i][j] = new JButton();
				this.field[i][j].addMouseListener(new MouseListener() {
					public void mouseClicked(MouseEvent event) {

					}

					public void mouseEntered(MouseEvent event) {
						TicTacToe.this.hover(event, true);
					}

					public void mouseExited(MouseEvent event) {
						TicTacToe.this.hover(event, false);
					}

					public void mousePressed(MouseEvent event) {

					}

					public void mouseReleased(MouseEvent event) {

					}
				});
				this.field[i][j].addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent event) {
						TicTacToe.this.click(event);
					}
				});
				this.field[i][j].setForeground(this.defaultColor);
				this.field[i][j].setFont(this.field[i][j].getFont().deriveFont(Font.BOLD, 24f));
				this.game.add(this.field[i][j]);
			}
		}
		this.game.updateUI();
	}

	private void hover(MouseEvent event, boolean hover) {
		int x = this.getField(event.getSource(), 0);
		int y = this.getField(event.getSource(), 1);
		if (hover) {
			if (this.field[x][y].getText().equals("") && this.field[x][y].getForeground().equals(this.defaultColor)) {
				this.field[x][y].setForeground(this.grayedColor);
				this.field[x][y].setText(this.signs[this.sign]);
			}
		} else {
			if (this.field[x][y].getText().equals(this.signs[this.sign]) && this.field[x][y].getForeground().equals(this.grayedColor)) {
				this.field[x][y].setForeground(this.defaultColor);
				this.field[x][y].setText("");
			}
		}
	}

	private void click(ActionEvent event) {
		int x = this.getField(event.getSource(), 0);
		int y = this.getField(event.getSource(), 1);
		if (this.field[x][y].getForeground().equals(this.grayedColor)) {
			this.field[x][y].setText(this.signs[this.sign]);
			this.field[x][y].setForeground(this.defaultColor);
			this.changeSign();
			String winner = this.check();
			if (winner.equals(" ")) {
				JOptionPane.showMessageDialog(this.window, "No winner.", "Information", JOptionPane.INFORMATION_MESSAGE);
				this.reset();
			} else if (!winner.equals("")) {
				JOptionPane.showMessageDialog(this.window, "Player " + winner + " is winner.", "Information", JOptionPane.INFORMATION_MESSAGE);
				this.reset();
			}
		} else {
			JOptionPane.showMessageDialog(this.window, "This field is already in use.", "Error", JOptionPane.ERROR_MESSAGE);
		}
	}

	private String check() {
		String winner = "";
		boolean noWinner = true;
		for (int sign = 0; sign < this.signs.length; sign++) {
			for (int i = 0; i < this.fields; i++) {
				int x = 0;
				int y = 0;
				for (int j = 0; j < this.fields; j++) {
					if (this.field[i][j].getText().equals(this.signs[sign])) {
						x++;
						if (x == this.fields) {
							winner = this.signs[sign];
						}
					}
					if (this.field[j][i].getText().equals(this.signs[sign])) {
						y++;
						if (y == this.fields) {
							winner = this.signs[sign];
						}
					}
				}
			}
			int a = 0;
			for (int i = 0; i < this.fields; i++) {
				if (this.field[i][i].getText().equals(this.signs[sign])) {
					a++;
					if (a == this.fields) {
						winner = this.signs[sign];
					}
				}
			}
			int b = 0;
			int j = this.fields - 1;
			for (int i = 0; i < this.fields; i++) {
				if (this.field[i][j].getText().equals(this.signs[sign])) {
					b++;
					if (b == this.fields) {
						winner = this.signs[sign];
					}
				}
				j--;
			}
		}
		for (int i = 0; i < this.fields; i++) {
			for (int j = 0; j < this.fields; j++) {
				if (!(winner.equals("") && !this.field[i][j].getText().equals(""))) {
					noWinner = false;
				}
			}
		}
		if (noWinner) {
			return " ";
		} else {
			return winner;
		}
	}

	private int getField(Object source, int mode) {
		int x = 0;
		int y = 0;
		for (int i = 0; i < this.fields; i++) {
			for (int j = 0; j < this.fields; j++) {
				if (source.equals(this.field[i][j])) {
					x = i;
					y = j;
				}
			}
		}
		if (mode == 0) {
			return x;
		} else if (mode == 1) {
			return y;
		}
		return 0;
	}

	private void changeSign() {
		if (this.sign < this.signs.length - 1) {
			this.sign++;
		} else {
			this.sign = 0;
		}
	}

	private void reset() {
		this.sign = 0;
		for (int i = 0; i < this.fields; i++) {
			for (int j = 0; j < this.fields; j++) {
				this.field[i][j].setText("");
				this.field[i][j].setForeground(this.defaultColor);
			}
		}
	}
}